=== gpu-voxels/packages/CMakeLists.txt ===
ADD_SUBDIRECTORY(icl_core)
ADD_SUBDIRECTORY(gpu_voxels)
