=== debian/control ===
Source: ros-melodic-gpu-voxels-ros
Section: misc
Priority: optional
Maintainer: aferreira <aferreira@todo.todo>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-catkin, ros-melodic-geometry-msgs, ros-melodic-nodelet, ros-melodic-pcl-ros, ros-melodic-pluginlib, ros-melodic-tf
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-gpu-voxels-ros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-geometry-msgs, ros-melodic-nodelet, ros-melodic-pcl-ros, ros-melodic-pluginlib, ros-melodic-tf
Description: The gpu_voxels package
